/* 
   xmdbot -- Autoplay robot for 'X Magical Dron'
                        by Yusuke Sato (g95p0557@mse.waseda.ac.jp) 
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <time.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Label.h>


/* for Linux */
#ifdef __Linux__
#include <getopt.h>
#endif
#ifdef linux
#include <getopt.h>
#endif



/* botselect() $B$G;HMQ$9$kBT$A9TNs(B (main()$B$G(B QUEUE_ $B8DJ,(B malloc.) */
#define MAX_CLIENT 10
#define MAX_MSG_LENGTH 150
#define QUEUE_ (5 * MAX_CLIENT * 2)
#define QUEUE_SIZE MAX_MSG_LENGTH
#define QUEUE_CHECK_INTERVAL 50  /* (ms) */

typedef struct xmd_queue_ {
  char readmes[QUEUE_SIZE];
  struct xmd_queue_ *next;
} xmd_queue;

xmd_queue *q_start;
xmd_queue *q_head;
int pr_q_size;         /* present queue size */



#define RENSA1 "1111111112"
#define RENSA2 "1111122334"
#define RENSA3 "1123344455"
#define RENSA4 "1234444555"

#define DEL1 "1110000000"
#define DEL2 "1111000000"
#define DEL3 "1111100000"
#define DEL4 "1111111000"

#define TATE 11
#define BUFSIZE 1024

XtAppContext app_con;
XtInputId selectid;

Widget toplevel, nick, nick_l, level, level_l, l1, l2, l3, l4;
Widget zombie, zombie_l, t, f, replay, replay_l, y, n, join, quit;
Widget stat_, stat_l, form, title;

int penalty[11] = {0,0,1,1,2,3,4,4,5,5,6};
                   /*  ^---- 2 rensa   /  max 10 rensa */

char rensa[15] = RENSA2;
char del[15] = DEL2;

int lev = 2;
int zom = 0;
int rep = 1;
int sta = 0;  /* not connected (0) or connected (1) */ 

int deadpd[10];

int fd;

int botyabasa = 7;
int botpd;

int st = 0;   /* compatible to xmdclient */
char mynick[10] = "xmdrobot";
int port = 4170;
char servername[100];
int persons;

int nickcollision = 0;

/* Prototype */
void levelchange(Widget, XtPointer, XtPointer);
void zombiechange(Widget, XtPointer, XtPointer);
void replaychange(Widget, XtPointer, XtPointer);
void join_(Widget, XtPointer, XtPointer);
void quit_(Widget, XtPointer, XtPointer);
void botmystate(XtPointer, XtIntervalId *);
void attack(XtPointer, XtIntervalId *);
void puyo_me(XtPointer, XtIntervalId *);
void delpuyo(XtPointer, XtIntervalId *);
void start_st(XtPointer, XtIntervalId *);
void getbotpd(char *);
void optcheck(int, char**);
void deadcheck(char *);
void botselect(XtPointer, int *, XtInputId *);
void bot_queue_check(XtPointer, XtIntervalId *);
void bot_exec_queue(char *);
int sconnect(void);


int main(int argc, char **argv){ 
  int i;
  xmd_queue *q_tmp;

  String fallback[] = {
    "*background: lightyellow",

    "*title.label: Xmdbot controller",
    "*title.width: 200",
    "*title.borderWidth: 0",

    "*nick_l.fromVert: title",
    "*nick_l.borderWidth: 0",
    "*nick_l.width: 80",
    "*nick_l.vertDistance: 25",
    "*nick_l.label: Nick",

    "*nick.fromVert: title",
    "*nick.fromHoriz: nick_l",
    "*nick.horizDistance: 20",
    "*nick.width: 100",
    "*nick.label: ",
    "*nick.resize: FALSE",
    "*nick.vertDistance: 25",


    "*stat_l.fromVert: nick",
    "*stat_l.borderWidth: 0",
    "*stat_l.width: 80",
    "*stat_l.vertDistance: 25",
    "*stat_l.label: Connected?",

    "*stat_.fromVert: nick",
    "*stat_.fromHoriz: stat_l",
    "*stat_.horizDistance: 20",
    "*stat_.width: 100",
    "*stat_.label: No",
    "*stat_.vertDistance: 25",

    "*level_l.fromVert: stat_l",
    "*level_l.vertDistance: 20",    
    "*level_l.borderWidth: 0",
    "*level_l.width: 80",
    "*level_l.label: Level",

    "*level.fromVert: stat_l",
    "*level.vertDistance: 20",
    "*level.fromHoriz: level_l",
    "*level.horizDistance: 20",
    "*level.width: 100",
    "*level.label: 2",
    
    "*l1.fromVert: level_l",
    "*l1.horizDistance: 106",
    "*l1.label: 1",
    "*l1.width: 15",
    
    "*l2.fromVert: level_l",
    "*l2.fromHoriz: l1",
    "*l2.horizDistance: 10",
    "*l2.label: 2",
    "*l2.width: 15",
    
    "*l3.fromVert: level_l",
    "*l3.fromHoriz: l2",
    "*l3.horizDistance: 10",
    "*l3.label: 3",
    "*l3.width: 15",
    
    "*l4.fromVert: level_l",
    "*l4.fromHoriz: l3",
    "*l4.horizDistance: 10",
    "*l4.label: 4",
    "*l4.width: 15",

    "*zombie_l.fromVert: l1",
    "*zombie_l.vertDistance: 20",    
    "*zombie_l.borderWidth: 0",
    "*zombie_l.width: 80",
    "*zombie_l.label: Zombie?",

    "*zombie.fromVert: l1",
    "*zombie.vertDistance: 20",    
    "*zombie.fromHoriz: zombie_l",
    "*zombie.horizDistance: 20",
    "*zombie.width: 100",
    "*zombie.label: No",

    "*t.fromVert: zombie_l",
    "*t.horizDistance: 110",
    "*t.label: Yes",

    "*f.fromVert: zombie_l",
    "*f.fromHoriz: t",
    "*f.horizDistance: 10",
    "*f.label: No",

    "*replay_l.fromVert: t",
    "*replay_l.vertDistance: 20",    
    "*replay_l.borderWidth: 0",
    "*replay_l.label: AutoReplay",
    "*replay_l.width: 80",

    "*replay.fromVert: t",
    "*replay.vertDistance: 20",    
    "*replay.horizDistance: 20",    
    "*replay.fromHoriz: replay_l",
    "*replay.label: Yes",
    "*replay.width: 100",

    "*y.fromVert: replay_l",
    "*y.horizDistance: 110",
    "*y.label:Yes",

    "*n.fromVert: replay_l",
    "*n.fromHoriz: y",
    "*n.horizDistance: 10",
    "*n.label:No",

    "*join.fromVert: n",
    "*join.label: Join",
    "*join.vertDistance: 20",

    "*quit.fromVert: n",
    "*quit.fromHoriz: join",
    "*quit.label: Quit",
    "*quit.vertDistance: 20",    
    NULL
  };



  
  q_start = q_tmp = (xmd_queue *)malloc(sizeof(xmd_queue));
  for(i=0; i<QUEUE_; i++){
    q_tmp->next = (xmd_queue *)malloc(sizeof(xmd_queue));
    q_tmp = q_tmp->next;
  }
  q_tmp->next = q_start;      /* Ring List */

  /* initialize */
  q_head = q_start;
  pr_q_size = 0;




  for(i = 0; i < 10; i++)
    deadpd[i] = -1;

  optcheck(argc, argv);

  toplevel = XtVaAppInitialize(&app_con, "Xmdbot", NULL, 0, 
			       &argc, argv, fallback, NULL);

  form = XtVaCreateManagedWidget("form",
 				 formWidgetClass, toplevel, NULL);
  title = XtVaCreateManagedWidget("title",
				  labelWidgetClass, form, NULL);
  nick_l = XtVaCreateManagedWidget("nick_l",
				   labelWidgetClass, form, NULL);
  nick = XtVaCreateManagedWidget("nick",
 				 labelWidgetClass, form, NULL);
  stat_l = XtVaCreateManagedWidget("stat_l",
				   labelWidgetClass, form, NULL);
  stat_ = XtVaCreateManagedWidget("stat_",
 				 labelWidgetClass, form, NULL);
  level_l = XtVaCreateManagedWidget("level_l",
				    labelWidgetClass, form, NULL);
  level = XtVaCreateManagedWidget("level",
				  labelWidgetClass, form, NULL);
  l1 = XtVaCreateManagedWidget("l1",
			       commandWidgetClass, form, NULL);
  l2 = XtVaCreateManagedWidget("l2",
			       commandWidgetClass, form, NULL);
  l3 = XtVaCreateManagedWidget("l3",
			       commandWidgetClass, form, NULL);
  l4 = XtVaCreateManagedWidget("l4",
			       commandWidgetClass, form, NULL);
  zombie_l = XtVaCreateManagedWidget("zombie_l",
				     labelWidgetClass, form, NULL);
  zombie = XtVaCreateManagedWidget("zombie",
				   labelWidgetClass, form, NULL);
  t = XtVaCreateManagedWidget("t",
			      commandWidgetClass, form, NULL);
  f = XtVaCreateManagedWidget("f",
			      commandWidgetClass, form, NULL);
  replay_l = XtVaCreateManagedWidget("replay_l",
				     labelWidgetClass, form, NULL);
  replay = XtVaCreateManagedWidget("replay",
				   labelWidgetClass, form, NULL);
  y = XtVaCreateManagedWidget("y",
			      commandWidgetClass, form, NULL);
  n = XtVaCreateManagedWidget("n",
			      commandWidgetClass, form, NULL);
  join = XtVaCreateManagedWidget("join",
				 commandWidgetClass, form, NULL);
  quit = XtVaCreateManagedWidget("quit",
				 commandWidgetClass, form, NULL);

  XtAddCallback(l1, XtNcallback, levelchange, (XtPointer)1);
  XtAddCallback(l2, XtNcallback, levelchange, (XtPointer)2);
  XtAddCallback(l3, XtNcallback, levelchange, (XtPointer)3);
  XtAddCallback(l4, XtNcallback, levelchange, (XtPointer)4);
 
  XtAddCallback(t, XtNcallback, zombiechange, (XtPointer)1);
  XtAddCallback(f, XtNcallback, zombiechange, (XtPointer)0);

  XtAddCallback(y, XtNcallback, replaychange, (XtPointer)1);
  XtAddCallback(n, XtNcallback, replaychange, (XtPointer)0);

  XtAddCallback(join, XtNcallback, join_, NULL);
  XtAddCallback(quit, XtNcallback, quit_, NULL);

  XtAppAddTimeOut(app_con, 5000,
		  botmystate,
		  NULL);

  XtAppAddTimeOut(app_con, 5000,
		  attack,
		  NULL);

  XtAppAddTimeOut(app_con, 1000,
		  delpuyo,
		  NULL);

  XtAppAddTimeOut(app_con, 3000,
		  puyo_me,
		  NULL);


  XtAppAddTimeOut(app_con, QUEUE_CHECK_INTERVAL,
		  bot_queue_check,
		  NULL);

  XtVaSetValues(nick,
		XtNlabel, mynick,
		NULL);

  XtRealizeWidget(toplevel);
  XtAppMainLoop(app_con);

  return (0);
}


void levelchange(Widget w, XtPointer client_data, XtPointer call_data){
  char tmp[3];

  if(sta == 0 || sta == 1){   /* $B$$$D$G$b??(B (^^; */
    lev = (int)client_data;
    sprintf(tmp, "%d", lev);
    XtVaSetValues(level,
		  XtNlabel, tmp,
		  NULL);

    switch(lev){
    case 1:
      strcpy(rensa, RENSA1);
      strcpy(del, DEL1);
      break;
    case 2:
      strcpy(rensa, RENSA2);
      strcpy(del, DEL2);
      break;
    case 3:
      strcpy(rensa, RENSA3);
      strcpy(del, DEL3);
      break;
    case 4:
      strcpy(rensa, RENSA4);
      strcpy(del, DEL4);
    }
  }
}

void zombiechange(Widget w, XtPointer client_data, XtPointer call_data){
  if(sta == 0 || sta == 1){
    zom = (int)client_data;
    if(zom == 0){
      botyabasa = 99;
      XtVaSetValues(zombie,
		    XtNlabel, "No",
		    NULL);
    }else{
      botyabasa = 7;
      XtVaSetValues(zombie,
		    XtNlabel, "Yes",
		    NULL);
    }
  }
}
		  
void replaychange(Widget w, XtPointer client_data, XtPointer call_data){
  if(sta == 0 || sta == 1){
    rep = (int)client_data;
    if(rep == 0){
      XtVaSetValues(replay,
		    XtNlabel, "No",
		    NULL);
    }else{
      XtVaSetValues(replay,
		    XtNlabel, "Yes",
		    NULL);
    }
  }
}

void join_(Widget w, XtPointer client_data, XtPointer call_data){
  char tmp[20];

  if(sta == 0){
    fd = sconnect();

    selectid = XtAppAddInput(app_con, fd, 
			     (XtPointer)XtInputReadMask, 
			     (XtInputCallbackProc)botselect, 
			     toplevel); 

    sprintf(tmp,"NICK:%s;",mynick);
    write(fd,tmp,strlen(tmp));

    XtVaSetValues(stat_,
		  XtNlabel, "Yes",
		  NULL);
    sta = 1; /* connected! */
    st = 0;

  }
}

void quit_(Widget w, XtPointer client_data, XtPointer call_data){
  char tmp[20];

  if(sta == 0){
    exit(0);
  }else if(st == 1){
    botyabasa = -1;
    sprintf(tmp, "MYSTATE:%d:*;", botpd);
    write(fd, tmp, strlen(tmp));
    st = 2;
  }
}

void botmystate(XtPointer client_data, XtIntervalId *id){
  char tmp[20];
  if(st == 1){

    if(zom == 1)
      botyabasa = 99;

    sprintf(tmp, "MYSTATE:%d:%d;", botpd, botyabasa);
    write(fd, tmp, strlen(tmp));
  }

  XtAppAddTimeOut(app_con, 5000,
		  botmystate,
		  NULL);
}


void botselect(XtPointer client_data,int *fdl,XtInputId *id){
  char readbuf[BUFSIZE];
  char buf_copy_for_strtok[BUFSIZE];
  int ret;
  char *p_token;

 
  if((ret = read(*fdl,readbuf,BUFSIZE)) <= 0){
    if(nickcollision == 1)
      fprintf(stderr,"Nickname collision.\nConnect to the server with another nickname.\n");
    else
      fprintf(stderr,"Maybe server down.\n");
    close(*fdl);
    exit(1);
  }
  readbuf[ret]='\0';

  strcpy(buf_copy_for_strtok,readbuf);

  p_token = strtok(buf_copy_for_strtok, ";");
  do{
    strcpy(q_head->readmes, p_token);
    strcat(q_head->readmes, ";");    /* $BIU$1$J$$$HBLL\(B(removed by strtok() */
    q_head = q_head->next;
    pr_q_size++;
    if(pr_q_size > QUEUE_){
      fprintf(stderr, "Warning: read_queue is FULL!");
      fflush(stderr);
      /* exit(1); */
    }
  }while( ( p_token = strtok(NULL, ";") ) != NULL);
  
}



void bot_queue_check(XtPointer client_data, XtIntervalId *id){
  xmd_queue *p_tmp;
  int i;

  if(pr_q_size == 0 || sta == 0){

    XtAppAddTimeOut(app_con, QUEUE_CHECK_INTERVAL,
		    bot_queue_check,
		    NULL);

  }else{
    p_tmp = q_start;
    for(i=0; i<pr_q_size; i++){
      
      bot_exec_queue(p_tmp->readmes);
      p_tmp = p_tmp->next;
      
    }

    XtAppAddTimeOut(app_con, QUEUE_CHECK_INTERVAL,
		    bot_queue_check,
		    NULL);

  }
}


void bot_exec_queue(char *readbuf){
  int i;
  char tmp[BUFSIZE];

  switch(st){

  case 0:

    if(strncmp(readbuf,"LIST",4) == 0)
      getbotpd(readbuf);

    if(strncmp(readbuf,"START",5) == 0){

      XtAppAddTimeOut(app_con, 5000,
		      start_st,
		      NULL);
    }

    if(strncmp(readbuf,"NICK",4) == 0)
      nickcollision = 1;

    break;

    
  case 1:
 
    if(strncmp(readbuf,"PUYO",4) == 0){
      botyabasa--;
      if(botyabasa == -1){
	sprintf(tmp, "MYSTATE:%d:*;", botpd);
	write(fd, tmp, strlen(tmp));
	st = 2;
      }
    }

    if(strncmp(readbuf,"WIN",3) == 0)
      st = 3;

    if(strncmp(readbuf,"ALLSTATE",8) == 0)
      deadcheck(readbuf);

    break;

  case 2:

    if(strncmp(readbuf,"WIN",3) == 0)
      st = 3;
    break;
  }

  if(st == 3){
    st = 4; /* switch $B$K$R$C$+$+$i$J$$(B */
    sta = 0;
    botyabasa = 7;

    for(i = 0; i < 10; i++)
      deadpd[i] = -1;


    XtRemoveInput(selectid);

    if(rep == 1){
      join_(toplevel, (XtPointer)NULL , (XtPointer)NULL);
    }else{
      XtVaSetValues(stat_,
		    XtNlabel, "No",
		    NULL);
    }
  }

      
  pr_q_size--;
  q_start = q_start->next;

}



void getbotpd(char *readbuf){
  int i = 4, j, k = 0;
  char nicktmp[150];

  while(readbuf[i]!=';'){
    j = 0;
    i++;

    while(readbuf[i] != ';' && readbuf[i] !=':'){
      nicktmp[j] = readbuf[i];
      j++;
      i++;
    }

    nicktmp[j]='\0';
    
    if (j!=0){
      if(strcmp(mynick,nicktmp) == 0){
	botpd = k; 
      }
      k++;
    }
  }  

  persons = k;

}

void puyo_me(XtPointer client_data, XtIntervalId *id){
  char tmp[20];

  if(st == 1 && zom == 0){
    sprintf(tmp, "REQUEST:%d:%d:1;", botpd, botpd);
    write(fd, tmp, strlen(tmp));
  }

  XtAppAddTimeOut(app_con, 3000,
		  puyo_me,
		  NULL);
}


void attack(XtPointer client_data, XtIntervalId *id){
  char tmp[25];
  char numconv[2];
  int target;
  int rnum;
  int okuru;
  int flag, i;
  time_t t;

  if(st == 1){
    t = (time(NULL) + rand()) % 30000;
    srand((unsigned int)t);
    do{
      flag = 0;
      target = rand() % persons;

      if(target == botpd)
	flag = 1;
      for(i = 0; i < 10; i++){
	if(deadpd[i] == 1 && target == i)
	  flag = 1;
      }
    }while(flag == 1);

    rnum = rand() % 10;

    numconv[0] = rensa[rnum];
    numconv[1] = '\0';
    okuru = penalty[atoi(numconv)];

    if(okuru != 0){
      sprintf(tmp, "REQUEST:%d:%d:%d;", botpd, target, okuru);
      write(fd, tmp, strlen(tmp));
    }
  }

  XtAppAddTimeOut(app_con, 5000,
		  attack,
		  NULL);

}

void delpuyo(XtPointer client_data, XtIntervalId *id){
  char numconv[2];
  time_t t;
  int rnum;

  if(st == 1){
    t = (time(NULL) + rand()) % 30000;
    srand((unsigned int)t);
    rnum = rand() % 10;

    numconv[0] = del[rnum];
    numconv[1] = '\0';

    botyabasa += atoi(numconv);

    if(botyabasa > TATE){
      botyabasa = TATE;
    }

  }


  XtAppAddTimeOut(app_con, 1000,
		  delpuyo,
		  NULL);
}

void optcheck(int argc, char **argv){
  int opt, sflag = 0;
  extern int opterr;
  extern char *optarg;

  opterr = 0;

  while(( opt = getopt(argc, argv, "s:p:n:")) != EOF){
    switch(opt){
    case 's':
      strcpy(servername, optarg);
      sflag = 1;
      break;
    case 'n':
      strncpy(mynick, optarg, 9);
      mynick[9] = '\0';
      break;
    case 'p':
      port = (int)atoi(optarg);
    }
  }

  if(sflag == 0){
    fprintf(stderr, "Usage: xmdbot -s servername [-p port -n nickname]\n");
    exit(1);
  }

}

void start_st(XtPointer client_data, XtIntervalId *id){
  st = 1;
}

void deadcheck(char *readbuf){
  char *p;
  int i = 0;

  p = strtok(readbuf, ":");

  do{
    p = strtok(NULL, ":");
    if(strcmp(p, "*") == 0)
      deadpd[i] = 1;
    i++;
  }while(i != persons);
}
