#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/List.h>
#include "xmd.h"

#define BUFSIZE 1024

int intpuyo;
extern int Lock;
extern int execLock;
extern int fd;
extern char unterminated_mes[150];

void xselect(XtPointer client_data,int *fdl,XtInputId *id){
  int i;
  char rbuf[BUFSIZE];
  char buf_copy_for_strtok[BUFSIZE];
  char *p_token;
  static int unterminated_flag = 0;

#ifdef CLI_DEBUG
  xmd_queue *p_tmp;
#endif
  
  if((i = read(*fdl,rbuf,1024)) <= 0){
    fprintf(stderr,"Maybe server down.\n");
    close(*fdl);
    exit(1);
  }
  rbuf[i]='\0';



#ifdef CLI_DEBUG
  printf("st = %d\nmsg = %s\n",st,rbuf);
  fflush(stdout);
#endif  


  strcpy(buf_copy_for_strtok,rbuf);

  if((p_token = strtok(buf_copy_for_strtok, ";")) != NULL){
    do{
      if(unterminated_flag == 1){
	strcat(unterminated_mes, p_token);
	strcpy(q_head->readmes, unterminated_mes);
	unterminated_mes[0] = '\0';
	unterminated_flag = 0;
      }else{
	strcpy(q_head->readmes, p_token);
      }
      strcat(q_head->readmes, ";");    /* $BIU$1$J$$$HBLL\(B(removed by strtok() */
      q_head = q_head->next;
      pr_q_size++;
      if(pr_q_size > QUEUE_){

	fprintf(stderr, "Warning: read_queue is FULL!\n");
	fprintf(stderr, "st = %d\n",st);
	fprintf(stderr, "Lock = %d\n", Lock);
	fprintf(stderr, "execLock = %d\n", execLock);
	fflush(stderr);
	/* exit(1); */

      }
    }while( ( p_token = strtok(NULL, ";") ) != NULL);
    
#ifdef CLI_DEBUG
    p_tmp = q_start;
    for(i=0; i<pr_q_size; i++){
      printf("queue[%d] = %s\n", i, p_tmp->readmes);
      p_tmp = p_tmp->next;
    }
#endif

  }else{
    /* $B<u?.%a%C%;!<%8$,(B";"$B$G=*$C$F$$$J$$!*(B */
    strcat(unterminated_mes, rbuf);
    unterminated_flag = 1;
  }
}


void queue_check(XtPointer client_data, XtIntervalId *id){
  xmd_queue *p_tmp;
  int i, q_size_tmp;

  if(pr_q_size == 0 || execLock == 1 || Lock == 1){

    XtAppAddTimeOut(app_con, QUEUE_CHECK_INTERVAL,
		    queue_check,
		    NULL);

  }else{
    p_tmp = q_start;
    q_size_tmp = pr_q_size;
    for(i=0; i < q_size_tmp; i++){
      if(exec_queue(p_tmp->readmes) == 0){
	p_tmp = p_tmp->next;
	pr_q_size--;
	q_start = q_start->next;
      }else{
	break;
      }
    }

    XtAppAddTimeOut(app_con, QUEUE_CHECK_INTERVAL,
		    queue_check,
		    NULL);

  }
}


int exec_queue(char *buf){
  int i,j;
  char tmp[BUFSIZE];



  if(execLock == 1 || Lock == 1){
    return 1;      /* exec $B<:GT(B */
  }

  switch(st){
  case 0:
    if(strncmp(buf,"PUYO",4)==0){
      puyo(buf);
    }
    if(strncmp(buf,"LIST",4)==0){
      listc(buf);
      XawListChange(names,namelist,0,0,False);
    }
    if(strncmp(buf,"START",5)==0){

      XtAppAddTimeOut(app_con, 500,
		      countdown,
		      NULL);

    }

    if(strncmp(buf,"NICK",4)==0){
      fprintf(stderr,"Nickname collision.\n
              Connect to the server with another nickname.\n");
      close(fd);
      exit(1);
    }
    break;

    
  case 1:
    if(strncmp(buf,"WIN",3)==0){
      winner=buf[4]-'0';
      for(i=0;i<persons;i++){
	if(i!=winner)yabasa[i]=-1;
      }
      rewritename();

      st=3;
      XtVaSetValues(message,XtNlabel,"You win",NULL);
      setclr();
      break;
    }

    if(strncmp(buf,"ALL",3)==0){
      getyabasa(buf);
      rewritename();

    }

    if(strncmp(buf,"PUYO",4)==0){
      if(puyo(buf)==0){
	yabasa[mypd]=-1;
	rewritename();

	XtVaSetValues(message,XtNlabel,"Game Over",NULL);
	setclr();
	
	/* $B;`K4Js9p(B */
	sprintf(tmp,"MYSTATE:%d:*;",mypd);
	write(fd,tmp,strlen(tmp));
	
	for (i=0;i<TATE;i++){
	  for (j=0;j<YOKO;j++){
	    map[j][i]=4;
	  }
	}
	draw(canvas);

	st=2;
      }
      draw(canvas);
    }      
    
    break;
    
  case 2:
    
    if(strncmp(buf,"WIN",3)==0){
      winner=buf[4]-'0';
      for(i=0;i<persons;i++){
	if(i!=winner)yabasa[i]=-1;
      }
      rewritename();

      sprintf(buf,"%s Win",nicknames[winner]);
      st=3;
      XtVaSetValues(message,XtNlabel,buf,NULL);
      setclr();
      break;
    }

    if(strncmp(buf,"ALL",3)==0){
      getyabasa(buf);
      rewritename();

    }
    
    break;
    
  }


  if(st==3){
    XtPopup(popup_shell,XtGrabExclusive);
    scoredisp();
    winnerdisp();
    st=4;
  }

  return 0;         /* exec succeeded */

}

void scoredisp(void){
  char tmp[50];
  int i;

  strcpy(Scorelist[0], "       Result");
  strcpy(Scorelist[1], "");

  score_.score = 0;
  for(i = 2; i < 11; i++){ 
    sprintf(tmp, "   %2d Rensa:  %5d", i, score_.rensa[i]);
    strcpy(Scorelist[i], tmp);
    score_.score += i * i * score_.rensa[i];
  }

  strcpy(Scorelist[11], "");
  sprintf(tmp, "Total score: %6d", score_.score);
  strcpy(Scorelist[12], tmp);
  if(score_.score > highscore)
    highscore = score_.score;
  sprintf(tmp, " High score: %6d", highscore);
  strcpy(Scorelist[13], tmp);
  Scorelist[14] =  NULL;
  XawListChange(scorelist, Scorelist, 0, 0, TRUE);
}



void winnerdisp(void){
  char tmp[50];
  int i, j;
  int existflag[10];

  strcpy(Winlist[0], "   nickname / win");
  strcpy(Winlist[1], "");

  for(i = 0; i < 10; i++){
    wintable[i].existnow = 0;
    existflag[i] = 0;
  }

  for(i = 0; i < 10; i++){
    for(j = 0; j < 10; j++){
      if(strcmp(nicknames[j],"NOUSE") == 0){
	existflag[j] = 1;
      }else{
	if(strcmp(nicknames[j], wintable[i].nick) == 0){
	  wintable[i].existnow = 1;
	  existflag[j] = 1;
	}
      }
    }
  }

  for(i = 0; i < 10; i++){
    if(existflag[i] == 0){
      for(j = 0; j < 10; j++){
	if(wintable[j].existnow == 0){
	  strcpy(wintable[j].nick, nicknames[i]);
	  wintable[j].win = 0;
	  wintable[j].existnow = 1;
	  existflag[i] = 1;
	  break;
	}
      }
    }
  }


  for(i = 0; i < 10; i++){
    if(strcmp(wintable[i].nick, nicknames[winner]) == 0 
       && wintable[i].existnow == 1)
      wintable[i].win++;
  }

  j = 2;
  for(i = 0; i < 10; i++){
    if(wintable[i].existnow == 1){
      sprintf(tmp, "  %9s:    %3d", wintable[i].nick, wintable[i].win);
      strcpy(Winlist[j], tmp);
      j++;
    }
  }


  for(i = j; i < 12; i++)
    strcpy(Winlist[i], "");

  Winlist[12] = NULL;


  for(i = 0; i < 10; i++){
    if(wintable[i].existnow == 0){
      strcpy(wintable[i].nick, "");
      wintable[i].win = 0;
    }
  }


  XawListChange(winlist, Winlist, 0, 0, TRUE);


}



int puyo(char *buf){
  char charpuyo[9];
  char msgg[30];
  int i, j, from = 0, dev = 1;

  for(i=5;i<13;i++){
    charpuyo[i-5]=buf[i];
  }
  charpuyo[8]='\0';


  
  if(st==1){
    from=buf[14]-'0';
    if(from!=mypd){

      sprintf(msgg,"attack from %s",nicknames[from]);
      XtVaSetValues(message,XtNlabel,msgg,NULL);
      setclr();
    } 
  }
  

  intpuyo = atoi(charpuyo);

  for (i=0;i<YOKO;i++){
    if (map[i][TATE-1]!=-1) return 0;
  }
  for (i=TATE-2;i>=0;i--){
    for (j=0;j<YOKO;j++){
      map[j][i+1]=map[j][i];
    }
  }

  if(st==1){
    if(from!=mypd){  
      for(i=0;i<YOKO;i++){
	map[i][0]=5;
      }
    }
    
    draw(canvas);
    Lock = 1;
    execLock = 1;
  }

  if(st == 1){

    XtAppAddTimeOut(app_con, (int)RAG/3, /* wait hikaeme */
		    anime_2,  /* anim. for white puyo */   
		    NULL);

  }else{
    for(i=0;i<YOKO;i++){
      map[i][0]=(intpuyo / dev % 10 )-1;
      dev=dev*10;
    }
  }

  return 1 ;
}



void anime_2(XtPointer client_data, XtIntervalId *id){
  int i, dev;

  dev = 1;
  for(i=0;i<YOKO;i++){
    map[i][0]=(intpuyo / dev % 10 ) - 1;
    dev=dev*10;
  }

  draw(canvas);
  Lock = 0;
  execLock = 0;
}




void listc(char *tmp){
  int i=4,j,k=0;
  char nicktmp[100];
  
  while(tmp[i]!=';'){
    j=0;
    i++;
    while(tmp[i]!=';' && tmp[i] !=':'){
      nicktmp[j]=tmp[i];
      j++;
      i++;
    }
    nicktmp[j]='\0';
    
    if (j!=0){
      strcpy(nicknames[k],nicktmp);
      if(strcmp(mynick,nicktmp)==0){
	mypd=k; 
      }
	k++;
  }
}  
  for(i=0;i<k;i++){
    sprintf(nicktmp,"%9s %2d",nicknames[i],yabasa[i]);
    namelist[i+2][3]='\0';
      strcat(namelist[i+2],nicktmp);
  }
  for(i=k;i<10;i++){
    namelist[i+2][3]='\0';
  }
  persons=k;
}


void initgame(void){


  XtVaSetValues(message,XtNlabel,"Game Start!",NULL);
  setclr();
  XawListChange(names,namelist,0,0,False);

  draw(canvas);

  id_timerequest = XtAppAddTimeOut(app_con, interval,
				   timerequest,
				   NULL);

}

void getyabasa(char *tmp){
  int i,j=9,k;
  char yabatmp[3];
  for (i=0;i<persons;i++){
    k=0;
    yabatmp[0]='\0';
    yabatmp[1]='\0';
    yabatmp[2]='\0';

    while(tmp[j]!=':' && tmp[j]!=';'){
      yabatmp[k]=tmp[j];
      j++;k++;
    }
    if (strncmp(yabatmp,"*",1)==0){
      yabasa[i]=-1;
      if(ta==i){
	ta=-1;
	XtVaSetValues(target,XtNlabel,"Random",NULL);
      }
    }else{
      yabasa[i]=atoi(yabatmp);
    }
    if(tmp[j]==';'){
      return;
    }else{
      j++;
    }
  }
}

void rewritename(void){
  int i;
  char tmp[100];
  for(i=0;i<persons;i++){
    if(yabasa[i]<0){
      sprintf(tmp,"%9s Dead",nicknames[i]);
    }else{
      sprintf(tmp,"%9s %2d",nicknames[i],yabasa[i]);
    }
    namelist[i+2][3]='\0';
    strcat(namelist[i+2],tmp);
  }
      XawListChange(names,namelist,0,0,False);  
}

void countdown(XtPointer client_data, XtIntervalId *id){
  static int count = 5;
  char countdownchar[20];

  if(set_clr_mes_id == 1){
    XtRemoveTimeOut(clr_mes_id);
    set_clr_mes_id = 0;
  }

  sprintf(countdownchar,"%d %d %d %d %d",count, count, count, count, count);
  XtVaSetValues(message,
		XtNlabel, countdownchar,
		NULL);


  if(count == 0){
    st = 1;
    count = 5;
    setclr();  /* message widget $B>C$7$N%?%$%`%"%&%H@_Dj(B */
    initgame(); 
  }else{
    count--;
    XtAppAddTimeOut(app_con, 1000,
		    countdown,
		    NULL);
  }

}


